//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>
#include <fstream.h>
//#include <iostream.h>
//#include <math.h>
#include <time.h>

#include "SDL.h"
#include "./sound/api/inc/fmod.h"


#define RND(x)		  (((x - (int)x) >= 0.5) ? ((int)x+1) : ((int)x))

// GLOBALS

unsigned long	screen_pitch;
SDL_Event	event;


// FUNCTIONS

void intro(SDL_Surface *screen);
int count_sprite_8(int x_start, int y_start, int x_stopp, int y_stopp, char *bitmap);
void draw_line(float x_float1, float y_float1, float x_float2, float y_float2, Uint16 color, Uint16 *SDL_screen);
void disp_buf(Uint16 *buffer, Uint16 *SDL_screen);
void fade_out(Uint16 *virtscr_from, Uint16 *virtscr_to, int count, Uint16 *R, Uint16 *G, Uint16 *B);
void fade_in(Uint16 *virtscr_from, Uint16 *virtscr_to, int count, Uint16 *R, Uint16 *G, Uint16 *B);
void load_640(char *fil, Uint16 *bitmap);
int are_done(void);
void type_text(char *text, int text_x, int text_y, Uint16 color, Uint16 *virtscr, char *bitmap);
void write_text(char *text, int x_text, int y_text, Uint16 col_org, char *font_bitmap, int *chars, Uint16 *SDL_screen);


// STRUCTS

struct raw_polygon
{
	float	x1, y1, z1;
	float	x2, y2, z2;
	float	x3, y3, z3;
};


struct polygon
{
	int ref_1;
	int ref_2;
	int ref_3;
};


struct subobject
{
	char		part_name[100];

	raw_polygon	*raw_polygons;
	polygon		*polygons;
	int		pols_in_sub;

	float		*vertex_list_x;
	float		*vertex_list_y;
	float		*vertex_list_z;
	int		verts_in_sub;
};


// OBJECTS

class object_3D
{
	private:


	public:
		char		object_name[100];
		float           sintab[800], costab[800];
		subobject	*subs;
		char		temp_string[100];
		int		ant_subs;				// Number of subobjects, max 100.
		int		ant_pols[100];				// Number of polygons in each subobject.
		long		count, count2, count3;
		double jall;
		float		x1, x2, x3, y1, y2, y3, z1, z2, z3;



	void read_file(char *filename)
	{
		for (count=0; count<800; count++)
		{
			sintab[count] = sin(count/63.66);
			costab[count] = cos(count/63.66);
		}


		ifstream object_file(filename);
		object_file.getline(temp_string, 100);

		for(count=0; count<100; count++)
			ant_pols[count]=0;
		ant_subs = 0;
		while(!object_file.eof())				// Read trough the whole file.
		{
			object_file.getline(temp_string, 100);
			if(strlen(temp_string) == 1)			// An empty line means ->
			{
				ant_subs++;				// a new subobject.
				ant_pols[ant_subs]-=2;			// Take away the blank line and the name.
			}
			ant_pols[ant_subs]++;
		}
		object_file.close();

		subs = new subobject[ant_subs];
		for(count=0; count<ant_subs; count++)
		{
			subs[count].pols_in_sub = ant_pols[count+1];
			subs[count].raw_polygons = new raw_polygon[subs[count].pols_in_sub];//polygon[ant_pols[count+1]];
			subs[count].polygons = new polygon[subs[count].pols_in_sub];//polygon[ant_pols[count+1]];
			subs[count].vertex_list_x = new float[3*subs[count].pols_in_sub];//polygon[ant_pols[count+1]];
			subs[count].vertex_list_y = new float[3*subs[count].pols_in_sub];//polygon[ant_pols[count+1]];
			subs[count].vertex_list_z = new float[3*subs[count].pols_in_sub];//polygon[ant_pols[count+1]];
		}

		ifstream object_file2(filename);
		object_file2 >> object_name;

		for(count=0; count<ant_subs; count++)
		{
			object_file2 >> subs[count].part_name;
			for(count2=0; count2<ant_pols[count+1]; count2++)
			{
				object_file2 >> subs[count].raw_polygons[count2].x1;
				object_file2 >> subs[count].raw_polygons[count2].y1;
				object_file2 >> subs[count].raw_polygons[count2].z1;
				object_file2 >> subs[count].raw_polygons[count2].x2;
				object_file2 >> subs[count].raw_polygons[count2].y2;
				object_file2 >> subs[count].raw_polygons[count2].z2;
				object_file2 >> subs[count].raw_polygons[count2].x3;
				object_file2 >> subs[count].raw_polygons[count2].y3;
				object_file2 >> subs[count].raw_polygons[count2].z3;
			}
		}
		object_file2.close();

/*		for(count=0; count<ant_subs; count++)
		{
			printf(subs[count].part_name);
			printf("\n");
			for(count2=0; count2<subs[count].pols_in_sub; count2++)
			{
				printf(" %g", subs[count].raw_polygons[count2].x1);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].y1);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].z1);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].x2);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].y2);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].z2);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].x3);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].y3);
				printf(" ");
				printf(" %g", subs[count].raw_polygons[count2].z3);
				printf("\n");
			}
		}
*/
		// Make a vertexlist from the raw polygons.
		for(count=0; count<ant_subs; count++)
		{
			count3=0;
			for(count2=0; count2<subs[count].pols_in_sub; count2++)
			{
				subs[count].vertex_list_x[count3] = subs[count].raw_polygons[count2].x1;
				subs[count].vertex_list_y[count3] = subs[count].raw_polygons[count2].y1;
				subs[count].vertex_list_z[count3] = subs[count].raw_polygons[count2].z1;
				count3++;

				subs[count].vertex_list_x[count3] = subs[count].raw_polygons[count2].x2;
				subs[count].vertex_list_y[count3] = subs[count].raw_polygons[count2].y2;
				subs[count].vertex_list_z[count3] = subs[count].raw_polygons[count2].z2;
				count3++;

				subs[count].vertex_list_x[count3] = subs[count].raw_polygons[count2].x3;
				subs[count].vertex_list_y[count3] = subs[count].raw_polygons[count2].y3;
				subs[count].vertex_list_z[count3] = subs[count].raw_polygons[count2].z3;
				count3++;
			}
			subs[count].verts_in_sub = count3;
		}

		// Find equal vertex's.
		count=0;
		for(count=0; count<ant_subs; count++)
		{
			for(count2=0; count2<subs[count].verts_in_sub; count2++)
			{
//				count3 = 0;
				for(count3=count2+1; count3<subs[count].verts_in_sub; count3++)
				{
					if(subs[count].vertex_list_x[count3] == subs[count].vertex_list_x[count2] &&
					   subs[count].vertex_list_y[count3] == subs[count].vertex_list_y[count2] &&
					   subs[count].vertex_list_z[count3] == subs[count].vertex_list_z[count2])
					{
//						printf("LIK\n");
						subs[count].vertex_list_x[count3] = 0;
						subs[count].vertex_list_y[count3] = 0;
						subs[count].vertex_list_z[count3] = 0;
					}
				}
			}
		}

		// Compress the vertexlist.
		count=2;
		long count4;
		for(count=0; count<ant_subs; count++)
		{
//			for(count4=0; count4<subs[count].verts_in_sub; count4++)
			for(count4=0; count4<5; count4++)
			{
			for(count2=0; count2<subs[count].verts_in_sub; count2++)
			{
				if(subs[count].vertex_list_x[count2] == 0 &&
				   subs[count].vertex_list_y[count2] == 0 &&
				   subs[count].vertex_list_z[count2] == 0)
				{
//					printf("JALLA %d\n", count);
					for(count3=count2; count3<subs[count].verts_in_sub-1; count3++)
					{
						{
							subs[count].vertex_list_x[count3] = subs[count].vertex_list_x[count3+1];
							subs[count].vertex_list_y[count3] = subs[count].vertex_list_y[count3+1];
							subs[count].vertex_list_z[count3] = subs[count].vertex_list_z[count3+1];
						}
					}
				}
			}
			}
		}


		for(count=0; count<ant_subs; count++)
		{
			subs[count].verts_in_sub = 0;
			for(count2=0; count2<subs[count].pols_in_sub; count2++)
			{
				if(!(subs[count].vertex_list_x[count2] == 0 &&
				     subs[count].vertex_list_y[count2] == 0 &&
				     subs[count].vertex_list_z[count2] == 0))
				{
					subs[count].verts_in_sub++;
				}
			}
//			printf("Verts: %d \n", subs[count].verts_in_sub);
		}


		for(count=0; count<ant_subs; count++)
		{
			for(count2=0; count2<subs[count].pols_in_sub; count2++)
			{
				for(count3=0; count3<=subs[count].verts_in_sub; count3++)
				{
					if(subs[count].raw_polygons[count2].x1 == subs[count].vertex_list_x[count3] &&
					   subs[count].raw_polygons[count2].y1 == subs[count].vertex_list_y[count3] &&
					   subs[count].raw_polygons[count2].z1 == subs[count].vertex_list_z[count3])
					{ subs[count].polygons[count2].ref_1 = count3; }
//						printf("count3: %d\n", count3);}
					if(subs[count].raw_polygons[count2].x2 == subs[count].vertex_list_x[count3] &&
					   subs[count].raw_polygons[count2].y2 == subs[count].vertex_list_y[count3] &&
					   subs[count].raw_polygons[count2].z2 == subs[count].vertex_list_z[count3])
					{ subs[count].polygons[count2].ref_2 = count3; }
					if(subs[count].raw_polygons[count2].x3 == subs[count].vertex_list_x[count3] &&
					   subs[count].raw_polygons[count2].y3 == subs[count].vertex_list_y[count3] &&
					   subs[count].raw_polygons[count2].z3 == subs[count].vertex_list_z[count3])
					{ subs[count].polygons[count2].ref_3 = count3; }
				}
			}
		}

/*
		for(count2=0; count2<subs[0].pols_in_sub; count2++)
		{
			printf("x: %g ", subs[0].vertex_list_x[count2]);
			printf("y: %g ", subs[0].vertex_list_y[count2]);
			printf("z: %g \n", subs[0].vertex_list_z[count2]);
		}
		printf("\n\n");
		for(count2=0; count2<subs[1].pols_in_sub; count2++)
		{
			printf("x: %g ", subs[1].vertex_list_x[count2]);
			printf("y: %g ", subs[1].vertex_list_y[count2]);
			printf("z: %g \n", subs[1].vertex_list_z[count2]);
		}
		printf("\n\n");
		for(count2=0; count2<subs[2].pols_in_sub; count2++)
		{
			printf("x: %g ", subs[2].vertex_list_x[count2]);
			printf("y: %g ", subs[2].vertex_list_y[count2]);
			printf("z: %g \n", subs[2].vertex_list_z[count2]);
		}
*/
/*		for(count=0; count<ant_subs; count++)
		{
			for(count2=0; count2<subs[count].pols_in_sub; count2++)
			{
				printf("pol[%d], %d, %d, %d\n", count2, subs[count].polygons[count2].ref_1,
				subs[count].polygons[count2].ref_2, subs[count].polygons[count2].ref_3);
			}
		}
*/
	}


	void rotate(int axe, int phi)
	{
		for(count=0; count<ant_subs; count++)
//count=1;
		{
			for(count2=0; count2<=subs[count].verts_in_sub; count2++)
			{
				x1 = subs[count].vertex_list_x[count2];
				y1 = subs[count].vertex_list_y[count2];
				z1 = subs[count].vertex_list_z[count2];

				if (axe==1)
				{
					subs[count].vertex_list_y[count2] = z1*sintab[phi] + y1*costab[phi];
					subs[count].vertex_list_z[count2] = z1*costab[phi] - y1*sintab[phi];
				}

				if (axe==2)
				{
					subs[count].vertex_list_x[count2] = x1*costab[phi] - z1*sintab[phi];
					subs[count].vertex_list_z[count2] = x1*sintab[phi] + z1*costab[phi];
				}

				if (axe==3)
				{
					subs[count].vertex_list_x[count2] = x1*costab[phi] - y1*sintab[phi];
					subs[count].vertex_list_y[count2] = x1*sintab[phi] + y1*costab[phi];
				}
			}
		}
	}

};




// MAIN

int main(void)
{
      	SDL_Surface 		*screen;
      	unsigned int 		video_flags=0;
	int 			fullscreen=1;


      	SDL_Init(SDL_INIT_VIDEO);
      	video_flags = (SDL_HWSURFACE | SDL_DOUBLEBUF);
      	if (fullscreen == 1)
      	{
      		video_flags = video_flags | SDL_FULLSCREEN;
		SDL_ShowCursor(0);
      	}
      	screen=SDL_SetVideoMode(640, 480, 16, video_flags);
	SDL_WM_SetCaption("  *** ich bin eine bratwurst (a Darklite-demo for BreakPoint 2003) ***", NULL);

	intro(screen);

        SDL_Quit();
	return 0;
}



// INTRO STARTS
void intro(SDL_Surface *screen)
{
	Uint16		*zero_adr_16 = (Uint16*)screen->pixels;	// Start of screenmemory.
	FMUSIC_MODULE	*mod = NULL;				// The module to be played.

	char		done;
	Uint32 		starttime, time;			// For frametiming.
	Uint16 		color_16;				// Pixelcolor.
	Uint16		col_R, col_G, col_B;			// RGB-components of the pixelcolor.
	char 		*font_1 = new char[63999];		// A bitmap with a font.
	char 		*shade_1 = new char[144000];		// A bitmap with a font.
	int            	*char_pos = new int[175];		// Where to find the letters in the font-bitmap.
	char           	*c64font = new char[38599];		// 8bit bitmap of C64-font.
	Uint16		*buffer_16 = new Uint16[307200];
	Uint16		*ichbin_16;
	char		*ichbin;
	Uint16		*darklite_16;
	Uint16		*presents_16;
	FSOUND_SAMPLE 	*samp1 = 0, *samp2 = 0;

	object_3D	text_3D;
	object_3D	stig_3D;
	int		x, y, x2, y2, x3, y3;
	float		xf, yf, xf2, yf2, xf3, yf3;
	int		point_1, point_2, point_3;
	int		x_temp, y_temp;
	unsigned long	count, count2, count3;
	unsigned long	offset;
	unsigned long	y_real;					// y-position * screenpitch.
	int		temp_int;
	long		temp1, temp2, temp3, temp4;

	int             phi_int, alpfa_int;
	float           phi_fp, alpfa_fp;
	Uint16          tab_R[32], tab_G[64], tab_B[32];
	float           sintab[800], costab[800];
	int		radius;
	float		scale_fact;

	int                 *sprite_8_1x;            // Array to store a sprites pixels positions.
	int                 *sprite_8_1y;            // Array to store a sprites pixels positions.
	char                *sprite_8_1col;	         // Array to store a sprites pixels color.


	screen_pitch = screen->pitch>>1;			// Divide by 2 because of 16bit(2 bytes) screenmodus.
//	ichbin_16 = (Uint16*) &ichbin;

	// LOAD NORMAL FONT STARTS
	ifstream font("./graphic/font_1.map");
	for (count=0; count<175; count++)
		font >>char_pos[count];
	font.close();

	ifstream font_file("./graphic/font_1.tga");
	font_file.seekg(786);
	font_file.read(font_1, 64000);
	font_file.close();
	// LOAD NORMAL FONT ENDS

	// LOAD C64-FONT STARTS
	ifstream c64fontfile("./graphic/c64_font.tga");
	c64fontfile.seekg(786);
	c64fontfile.read(c64font, 38500);
	c64fontfile.close();
 	// LOAD C64-FONT ENDS

	// PRECALC SIN/COS-TAB STARTS.
	for (count=0; count<800; count++)
	{
		sintab[count] = sin(count/63.66);
		costab[count] = cos(count/63.66);
	}
	// PRECALC SIN/COS-TAB ENDS.

	// LOAD MUSIC STARTS
	FSOUND_SetOutput(FSOUND_OUTPUT_OSS);
	FSOUND_Init(44100, 64, FSOUND_INIT_GLOBALFOCUS);
//	mod = FMUSIC_LoadSong("./sound/invtro94.s3m");
//	mod = FMUSIC_LoadSong("./sound/Ndoftime.it");
	mod = FMUSIC_LoadSong("./sound/C64UPDAT.XM");
	SDL_Delay(1000);
	// LOAD MUSIC ENDS






	// INTRO STARTS
	col_R=0;
	col_G=0;
	col_B=31;

	color_16 = col_R;
	color_16 = color_16<<6;
	color_16 += col_G;
	color_16 = color_16<<5;
	color_16 += col_B;

	done = 0;
	Uint32	starttime2=SDL_GetTicks();

	// C64-THING STARTS
	starttime=SDL_GetTicks();
	while (SDL_LockSurface(screen) <0 );

	// Draw the C64-screen.
	for (y=0; y<480; y++)
	{
		y_real = y*screen_pitch;
		for (x=0; x<640; x++)
			zero_adr_16[y_real + x]=color_16;
	}

	for(y=0; y<55; y++)
	{
		for(x=0; x<640; x++)
		{
			zero_adr_16[screen_pitch*y + x] = 0x555F;
			zero_adr_16[screen_pitch*(y+425) + x] = 0x555F;
		}
	}

	for(y=55; y<425; y++)
	{
		for(x=0; x<50; x++)
		{
			zero_adr_16[screen_pitch*y + x] = 0x555F;
			zero_adr_16[screen_pitch*y + (x+595)] = 0x555F;
		}
	}

	type_text("    **** COMMODORE 64 BASIC V2 ****",45 , 60+15, 0x555F, zero_adr_16, c64font);
	type_text(" 64K RAM SYSTEM  38911 BASIC BYTES FREE",45 , 90+15, 0x555F, zero_adr_16, c64font);
	type_text("READY.",50 , 120+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);

	// Write on the C64-screen.
	count=0;
	while(count<=2 && !done)
	{
		starttime=SDL_GetTicks();
		while (SDL_LockSurface(screen) <0 );
		type_text("_",50 , 134+15, 0x555F, zero_adr_16, c64font);
		SDL_UnlockSurface(screen);
		SDL_Flip(screen);
		while((SDL_GetTicks() - starttime) < 500 && done==0)	{ if(are_done()) done=1; }

		starttime=SDL_GetTicks();
		while (SDL_LockSurface(screen) <0 );
		for(y=134+15; y<147+15; y++)
		{
			for(x=50; x<64; x++)
			{
				zero_adr_16[screen_pitch*y + x] = 0x001F;
			}
		}
		SDL_UnlockSurface(screen);	SDL_Flip(screen);
		while((SDL_GetTicks() - starttime) < 500 && done==0)	{ if(are_done()) done=1; }

		count++;
	}

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("L_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 300 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LO_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOA_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOAS_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 700 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOA_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 150 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOAD_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 500 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADf_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 150 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfP_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 300 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC _",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC E_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EM_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMU_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 100 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMUL_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 150 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULA_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULAT_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 150 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULATO_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 250 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULATOR_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 500 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULATORf_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULATORf,_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 300 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULATORf,8_",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=134+15; y<147+15; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("LOADfPC EMULATORf,8",50 , 134+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 200 && done==0)	{ if(are_done()) done=1; }


	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	type_text("SEARCHING",50 , 149+15, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 1000 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	type_text("LOADING",50 , 149+30, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 4000 && done==0)	{ if(are_done()) done=1; }


	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	type_text("READY.",50 , 164+30, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
//	while((SDL_GetTicks() - starttime) < 00 && done==0)	{ if(are_done()) done=1; }


	count=0;
	while(count<=1 && !done)
	{
		starttime=SDL_GetTicks();
		while (SDL_LockSurface(screen) <0 );
		type_text("_",50 , 179+30, 0x555F, zero_adr_16, c64font);
		SDL_UnlockSurface(screen);
		SDL_Flip(screen);
		while((SDL_GetTicks() - starttime) < 500 && done==0)	{ if(are_done()) done=1; }

		starttime=SDL_GetTicks();
		while (SDL_LockSurface(screen) <0 );
		for(y=179+30; y<195+30; y++)
		{
			for(x=50; x<64; x++)
			{
				zero_adr_16[screen_pitch*y + x] = 0x001F;
			}
		}
		SDL_UnlockSurface(screen);	SDL_Flip(screen);
		while((SDL_GetTicks() - starttime) < 500 && done==0)	{ if(are_done()) done=1; }

		count++;
	}


	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=179+30; y<195+30; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("_",50 , 179+30, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 400 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=179+30; y<195+30; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("R_",50 , 179+30, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 250 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=179+30; y<195+30; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("RU_",50 , 179+30, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 150 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=179+30; y<195+30; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("RUN_",50 , 179+30, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 150 && done==0)	{ if(are_done()) done=1; }

	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	for(y=179+30; y<195+30; y++)  { for(x=50; x<500; x++)  { zero_adr_16[screen_pitch*y + x] = 0x001F;  }  }
	type_text("RUN",50 , 179+30, 0x555F, zero_adr_16, c64font);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 2000 && done==0)	{ if(are_done()) done=1; }

	// Make the screen flicker while loading.
	count = 0;
	while(count<80 && !done)
	{
		starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
		offset = 0;
		while(offset<30)
		{
			if((offset+count)%5 == 0)
				{col_R=26; col_G=53; col_B=5;}
			else if((offset+count)%5 == 1)
				{col_R=30; col_G=5; col_B=5;}
			else if((offset+count)%5 == 2)
				{col_R=10; col_G=5; col_B=31;}
			else if((offset+count)%5 == 3)
				{col_R=10; col_G=45; col_B=5;}
			else if((offset+count)%5 == 4)
				{col_R=20; col_G=55; col_B=15;}
			else
				{col_R=0; col_G=0; col_B=0;}

			color_16  = col_R;			color_16 = color_16<<6;
			color_16 += col_G;			color_16 = color_16<<5;
			color_16 += col_B;

			for(y=(offset*16); y<((offset*16)+16); y++)
			{
				y_real = y*screen_pitch;
				for(x=0; x<640; x++)
					zero_adr_16[y_real + x]=color_16;
			}
			offset++;
		}
		SDL_UnlockSurface(screen);	SDL_Flip(screen);
		count++;
		if(are_done()) done=1;
		while((SDL_GetTicks() - starttime) < 35);
	}

	// C64-THING ENDS



	// WINDOWS-THING STARTS
	samp1 = FSOUND_Sample_Load(FSOUND_UNMANAGED, "./sound/windowsloader.wav", FSOUND_NORMAL, 0);
        FSOUND_PlaySound(FSOUND_FREE, samp1);


	while (SDL_LockSurface(screen) <0 );	starttime = SDL_GetTicks();
	load_640("./graphic/boot.tga", buffer_16);
	disp_buf(buffer_16, zero_adr_16);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);

	for(count2=0; count2<6; count2++)
	{
	for(count=0; count<110; count++)
	{
		while (SDL_LockSurface(screen) <0 );	starttime = SDL_GetTicks();
		disp_buf(buffer_16, zero_adr_16);
		for(x=300; x<340; x++)
		{
			for(y=353; y<364; y++)
			{
					zero_adr_16[screen_pitch*y + x] = 0x0000;
			}
		}

		if(count%8 < 4)
		{
			for(x=3; x<15; x++)
			{
				for(y=180; y<196; y++)
				{
					if(font_1[320*y + x] == 28)
						zero_adr_16[screen_pitch*(y+171) + (x+253+count)] = 0xF000;
				}
			}
		}
		else
		{
			for(x=15; x<32; x++)
			{
				for(y=180; y<196; y++)
				{
					if(font_1[320*y + x] == 28)
						zero_adr_16[screen_pitch*(y+171) + (x+253+count-12)] = 0xF000;
				}
			}
		}

		SDL_UnlockSurface(screen);	SDL_Flip(screen);
		while((SDL_GetTicks() - starttime) < 20 && done==0);	{ if(are_done()) {done=1; count2=5;}}
	}
	}
	FSOUND_Sample_Free(samp1);

//	while((SDL_GetTicks() - starttime) < 5000 && done==0);	{ if(are_done()) {done=1;}}

	load_640("./graphic/Image.tga", buffer_16);

	for(count=0; count<100; count++)
	{
	while (SDL_LockSurface(screen) <0 );	starttime = SDL_GetTicks();
	disp_buf(buffer_16, zero_adr_16);
	if(count==0)
		while((SDL_GetTicks() - starttime) < 3000 && done==0);	{ if(are_done()) {done=1;}}

	for(x=35; x<50; x++)
	{
		for(y=170; y<196; y++)
		{
			if(font_1[320*y + x] == 0)
				zero_adr_16[screen_pitch*(y+190-count) + (x+355)] = 0xFFFF;
		}
	}
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 10 && done==0);	{ if(are_done()) {done=1; count=100;}}
	}

	while((SDL_GetTicks() - starttime) < 1500 && done==0);	{ if(are_done()) {done=1;}}

	// WINDOWS-THING ENDS



	FMUSIC_PlaySong(mod);					// Start playing module.



	// INTROTEXT STARTS
	for(count=0; count<32; count++)
	{
		tab_R[count] = 0;
		tab_G[count] = 0;
		tab_G[count+32] = 0;
		tab_B[count] = 0;
	}

	ichbin_16 = new Uint16[307200];
	load_640("./graphic/diversefittedritt.tga", ichbin_16);
	darklite_16 = new Uint16[307200];
	load_640("./graphic/darklitebildeforfaen.tga", darklite_16);
	presents_16 = new Uint16[307200];
	load_640("./graphic/presentsbilde.tga", presents_16);

	for(count2=0; count2<7; count2++)
	{
//		starttime=SDL_GetTicks();

		if(count2==0)
		{y2=0; y3=28; y_temp=200;}
//		if(count2==2)
//		{y2=121; y3=215; y_temp=70;}
		if(count2==3)
		{y2=215; y3=257; y_temp=0;}
		if(count2==4)
		{y2=257; y3=330; y_temp=-60;}
		if(count2==5)
		{y2=340; y3=420; y_temp=-130;}
		if(count2==6)
		{y2=420; y3=479; y_temp=-210;}

		if(count2==1)
		{
			for (count=0; count<31; count+=1)
			{
				while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
				fade_in(darklite_16, zero_adr_16, count, tab_R, tab_G, tab_B);
				SDL_UnlockSurface(screen);	SDL_Flip(screen);
				while((SDL_GetTicks() - time) < 30 && done==0);	{ if(are_done() || done==1) {done=1; count2=6; count=32;}}
			}
//			count = 0;

			while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
			disp_buf(darklite_16, zero_adr_16);
			SDL_UnlockSurface(screen);	SDL_Flip(screen);
			while((SDL_GetTicks() - time) < 1300 && done==0);	{ if(are_done() || done==1) {done=1; count2=6;}}

			for (count=0; count<31; count+=1)
			{
				while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
				fade_out(darklite_16, zero_adr_16, count, tab_R, tab_G, tab_B);
				SDL_UnlockSurface(screen);	SDL_Flip(screen);
				while((SDL_GetTicks() - time) < 30 && done==0);	{ if(are_done() || done==1) {done=1; count2=6; count=32;}}
			}
//			count = 0;
//			while (SDL_LockSurface(screen) <0 );
		}
		else if(count2==2)
		{
			for (count=0; count<31; count+=1)
			{
				while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
				fade_in(presents_16, zero_adr_16, count, tab_R, tab_G, tab_B);
				SDL_UnlockSurface(screen);	SDL_Flip(screen);
				while((SDL_GetTicks() - time) < 30 && done==0);	{ if(are_done() || done==1) {done=1; count2=6; count=32;}}
			}
//			count = 0;

			while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
			disp_buf(presents_16, zero_adr_16);
			SDL_UnlockSurface(screen);	SDL_Flip(screen);
			while((SDL_GetTicks() - time) < 1200 && done==0);	{ if(are_done() || done==1) {done=1; count2=6;}}

			for (count=0; count<31; count+=1)
			{
				while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
				fade_out(presents_16, zero_adr_16, count, tab_R, tab_G, tab_B);
				SDL_UnlockSurface(screen);	SDL_Flip(screen);
				while((SDL_GetTicks() - time) < 30 && done==0);	{ if(are_done() || done==1) {done=1; count2=6; count=32;}}
			}
//			count = 0;
//			while (SDL_LockSurface(screen) <0 );
		}
		else
		{
			for(count=0; count<307200; count++)
				buffer_16[count] = 0x0000;

			for(y=y2; y<y3; y++)
			{
				for(x=0; x<640; x++)
				{
					buffer_16[screen_pitch*(y+y_temp) + x] = ichbin_16[640*y + x];
				}
			}

			for (count=0; count<31; count+=1)
			{
				while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
				fade_in(buffer_16, zero_adr_16, count, tab_R, tab_G, tab_B);
				SDL_UnlockSurface(screen);	SDL_Flip(screen);
				while((SDL_GetTicks() - time) < 30 && done==0);	{ if(are_done()) {done=1; count2=6; count=32;}}
			}

			while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
			disp_buf(buffer_16, zero_adr_16);
			SDL_UnlockSurface(screen);	SDL_Flip(screen);
			while((SDL_GetTicks() - time) < 1300 && done==0);	{ if(are_done()) {done=1; count2=6;}}

			for (count=0; count<31; count+=1)
			{
				while (SDL_LockSurface(screen) <0 );	time = SDL_GetTicks();
				fade_out(buffer_16, zero_adr_16, count, tab_R, tab_G, tab_B);
				SDL_UnlockSurface(screen);	SDL_Flip(screen);
				while((SDL_GetTicks() - time) < 30 && done==0);	{ if(are_done()) {done=1; count2=6; count=32;}}
			}
		}
	}
	delete [] ichbin_16;
	delete [] darklite_16;
	delete [] presents_16;
	// INTROTEXT ENDS







	// WRAPPER STARTS
	load_640("./graphic/ichbineinebratwurst.tga", buffer_16);
	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
	disp_buf(buffer_16, zero_adr_16);
	for(y=250; y<300; y++)
	{
		for(x=0; x<230; x++)
		{
			zero_adr_16[screen_pitch*y + x] = 0xF7FF;
		}
	}
	for(y=267; y<340; y++)
	{
		for(x=400; x<639; x++)
		{
			zero_adr_16[screen_pitch*y + x] = 0xF7FF;
		}
	}
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 3000 && done==0);	{ if(are_done()) {done=1;}}

	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
	disp_buf(buffer_16, zero_adr_16);
	for(y=267; y<340; y++)
	{
		for(x=400; x<639; x++)
		{
			zero_adr_16[screen_pitch*y + x] = 0xF7FF;
		}
	}
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 3000 && done==0);	{ if(are_done()) {done=1;}}

	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
	disp_buf(buffer_16, zero_adr_16);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 3000 && done==0);	{ if(are_done()) {done=1;}}


	x_temp = 320;
	y_temp = 240;

	for(count3=0; count3<2; count3++)
	{
		for (count2 = 0; count2<400; count2++)
		{
			starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
//	disp_buf(buffer_16, zero_adr_16);
			x_temp = (int) (320+100*sin(count2/63.67));
			y_temp = (int) (240+35*cos(count2/63.67));

			for (radius=50; radius>0; radius--)
			{
				for (count=0; count<400; count++)
				{
    					x = (int) (x_temp+(radius*costab[count]));
					y = (int) (y_temp+(radius*sintab[count]));
					color_16 = buffer_16[640*y + x];

					x = (int) (x_temp+(radius*costab[count+100-radius-radius]));
					y = (int) (y_temp+(radius*sintab[count+100-radius-radius]));
//					x = x_temp+(radius*costab[count+40-radius]);
//					y = y_temp+(radius*sintab[count+40-radius]);
					zero_adr_16[screen_pitch*y + x] = color_16;
				}
			}
			SDL_UnlockSurface(screen);	SDL_Flip(screen);
			if(are_done())	{count2=400; count3=3;};
			while((SDL_GetTicks() - starttime) < 15);
//			printf("Ticks: %d", SDL_GetTicks()-starttime);
		}
	}

	// WRAPPER ENDS



	// BUSS STARTS
        FMUSIC_SetPaused(mod, 1);
	samp2 = FSOUND_Sample_Load(FSOUND_UNMANAGED, "./sound/fess.wav", FSOUND_NORMAL, 0);

	load_640("./graphic/overfyltbussdritt.tga", buffer_16);
	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
        FSOUND_PlaySound(FSOUND_FREE, samp2);
	disp_buf(buffer_16, zero_adr_16);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 8000 && done==0);	{ if(are_done()) {done=1;}}

	FSOUND_Sample_Free(samp2);
	FMUSIC_SetPaused(mod, 0);
	// BUSS ENDS





	// PLASMA STARTS.
	for (phi_fp=0; phi_fp<5; phi_fp+=0.02)
	{
	starttime=SDL_GetTicks();	while (SDL_LockSurface(screen) <0 );
	if(are_done() || done==1) {phi_fp=20; done=1;}

	for (y=0; y<120; y++)
//	for (x=0; x<160; x++)
	{
		temp1=screen_pitch*y;
		temp2=screen_pitch*(239-y);
//		for (y=0; y<120; y++)
		for (x=0; x<160; x++)
		{
			temp_int = (int) (31*sin(x/1/51.0+phi_fp));
			if (temp_int<0)
				temp_int *= -1;
			col_R = temp_int;

			temp_int = (int) (63*cos((x/1/51.0)+cos(y/1/38.3+phi_fp)-phi_fp/3));
			if (temp_int<0)
				temp_int *= -1;
			col_G = temp_int;

			temp_int = (int) (31*cos((y/1/38.3)+sin(x/1/51.0+phi_fp*1.5)));
			if (temp_int<0)
				temp_int *= -1;
			col_B = temp_int;

			color_16  = col_R;			color_16 = color_16<<6;
			color_16 += col_G;			color_16 = color_16<<5;
			color_16 += col_B;

			zero_adr_16[temp1 +x] = color_16;
			zero_adr_16[temp1 +(319-x)] = color_16;
			zero_adr_16[temp2 +x] = color_16;
			zero_adr_16[temp2 +(319-x)] = color_16;

			zero_adr_16[temp1 +x+320] = color_16;
			zero_adr_16[temp1 +(319-x+320)] = color_16;
			zero_adr_16[temp2 +x+320] = color_16;
			zero_adr_16[temp2 +(319-x+320)] = color_16;

			zero_adr_16[screen_pitch*(y+240) +x] = color_16;
			zero_adr_16[screen_pitch*(y+240) +(319-x)] = color_16;
			zero_adr_16[screen_pitch*(239-y+240) +x] = color_16;
			zero_adr_16[screen_pitch*(239-y+240) +(319-x)] = color_16;

			zero_adr_16[screen_pitch*(y+240) +x+320] = color_16;
			zero_adr_16[screen_pitch*(y+240) +(319-x+320)] = color_16;
			zero_adr_16[screen_pitch*(239-y+240) +x+320] = color_16;
			zero_adr_16[screen_pitch*(239-y+240) +(319-x+320)] = color_16;

		}
	}
	write_text("BRATWURST GIVES ME GAS!!!", 200, 230, 0x0000, font_1, char_pos, zero_adr_16);
	while((SDL_GetTicks() - starttime) < 40);
//	printf("Ticks: %d", SDL_GetTicks()-starttime);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	}
	// PLASMA ENDS.



	// BREAKPOINT STARTS.
	load_640("./graphic/msdiedsowewenttobreakpoint2003.tga", buffer_16);
	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
	disp_buf(buffer_16, zero_adr_16);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 5000 && done==0);	{ if(are_done()) {done=1;}}
	// BREAKPOINT ENDS.



	// CYBERGIRL STARTS.
	load_640("./graphic/cyberkjerring.tga", buffer_16);
//	load_640("./graphic/cyberkjerringamihareifele.tga", buffer_16);
//	ifstream shade_file("./graphic/Shade.tga");
	ifstream shade_file("./graphic/fesshuggu.tga");
	shade_file.seekg(786);
	shade_file.read(shade_1, 144000);
	shade_file.close();
//	temp_int = count_sprite_8(0, 0, 150, 150, shade_1);

	temp_int = 0;
	for(y=0; y<300; y++)
	{
		for(x=0; x<480; x++)
		{
			if(shade_1[480*y + x] != 0)
			{
//				zero_adr_16[screen_pitch*y + x] = shade_1[320*y + x];
				temp_int++;
			}
		}
	}
	printf("FITTE: %d\n", temp_int);

	sprite_8_1x = new int[temp_int-1];
	sprite_8_1y = new int[temp_int-1];
    	sprite_8_1col = new char[temp_int-1];

	count = 0;
	for(y=0; y<300; y++)
	{
		for(x=0; x<480; x++)
		{
			if(shade_1[480*y + x] != 0)
			{
				sprite_8_1x[count] = x;
				sprite_8_1y[count] = y;
				sprite_8_1col[count] = shade_1[480*y + x];
				count++;
			}
		}
	}

	for(count2=0; count2<900; count2+=4)
	{
	if(are_done())
	{
		done=1;
		count2=900;
	}

	disp_buf(buffer_16, zero_adr_16);
	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
	for(count=0; count<temp_int; count++)
	{
		x_temp = (int) (100+100*sin(count2/63.67));
		y_temp = (int) (100+40*cos(count2/63.67));

		color_16 = buffer_16[640*(sprite_8_1y[count]+y_temp) + sprite_8_1x[count]+x_temp];

		col_R = col_G = col_B = color_16;
		col_R = col_R>>11;
		col_G = col_G<<5; col_G = col_G>>10;
		col_B = col_B<<11; col_B = col_B>>11;

		col_R += (sprite_8_1col[count])/1;
		col_G += (sprite_8_1col[count])*2;
		col_B += (sprite_8_1col[count])/1;

		if(col_R>31)
			col_R=31;
		if(col_G>63)
			col_G=63;
		if(col_B>31)
			col_B=31;

		color_16  = col_R;			color_16 = color_16<<6;
		color_16 += col_G;			color_16 = color_16<<5;
		color_16 += col_B;

		if(sprite_8_1col[count])
		zero_adr_16[screen_pitch*(sprite_8_1y[count]+y_temp) + sprite_8_1x[count]+x_temp] = color_16;
	}

	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 30 && done==0);
	}
	// CYBERGIRL ENDS.



	// DASS STARTS.
	load_640("./graphic/heatingtubes.tga", buffer_16);
	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
	disp_buf(buffer_16, zero_adr_16);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 5000 && done==0);	{ if(are_done()) {done=1;}}
	// DASS ENDS.



	// STIG STARTS.
	load_640("./graphic/trynethassstigmedwireframeboks.tga", buffer_16);
	stig_3D.read_file("./graphic/Head.raw");

//	scale_fact = 17;

	for(phi_int=0; phi_int<800; phi_int+=1)
	{
		starttime = SDL_GetTicks();

	stig_3D.rotate(1, 4);
	stig_3D.rotate(3, 4);
	while (SDL_LockSurface(screen) <0 );
	disp_buf(buffer_16, zero_adr_16);

	if(phi_int>300 && phi_int<350)
	{
		scale_fact -= 0.3;
	}
	else if(phi_int>=350 && phi_int<400)
	{
		scale_fact += 0.3;
	}
	else if(phi_int>=400 && phi_int<450)
	{
		scale_fact -= 0.3;
	}
	else if(phi_int>=450 && phi_int<500)
	{
		scale_fact += 0.3;
	}
	else if(phi_int>=500 && phi_int<550)
	{
		scale_fact -= 0.3;
	}
	else if(phi_int>=550 && phi_int<600)
	{
		scale_fact += 0.3;
	}
	else
	{
		scale_fact = 17;
	}

	x = 400;
	y = 240;
	color_16=0xFFB0;

	for(count2=0; count2<stig_3D.ant_subs; count2 ++)
	{
		for(count=0; count<stig_3D.subs[count2].pols_in_sub; count++)
		{
//			draw_line(20, 20, 100, 100, 0xFFFF, zero_adr_16);
			point_1 = stig_3D.subs[count2].polygons[count].ref_1;
			point_2 = stig_3D.subs[count2].polygons[count].ref_2;
			point_3 = stig_3D.subs[count2].polygons[count].ref_3;

			xf = (stig_3D.subs[count2].vertex_list_x[point_1]*scale_fact);
			yf = (stig_3D.subs[count2].vertex_list_y[point_1]*scale_fact);

			xf2 = (stig_3D.subs[count2].vertex_list_x[point_2]*scale_fact);
			yf2 = (stig_3D.subs[count2].vertex_list_y[point_2]*scale_fact);

			xf3 = (stig_3D.subs[count2].vertex_list_x[point_3]*scale_fact);
			yf3 = (stig_3D.subs[count2].vertex_list_y[point_3]*scale_fact);

			draw_line(xf+x, yf+y, xf2+x, yf2+y, color_16, zero_adr_16);
			draw_line(xf+x, yf+y, xf3+x, yf3+y, color_16, zero_adr_16);
			draw_line(xf2+x, yf2+y, xf3+x, yf3+y, color_16, zero_adr_16);
		}

	}
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 20 && done==0);	{ if(are_done()) {done=1; phi_int=1000;}}
	}

	// STIG ENDS.



	// FIRE STARTS.
	load_640("./graphic/campfire.tga", buffer_16);
	while (SDL_LockSurface(screen) <0 );	starttime=SDL_GetTicks();
	disp_buf(buffer_16, zero_adr_16);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 5000 && done==0);	{ if(are_done()) {done=1;}}
	// FIRE ENDS.



	// 3D STARTS


	load_640("./graphic/einslagsbakgrunn.tga", buffer_16);
	text_3D.read_file("./graphic/text.raw");
	text_3D.rotate(1, 200);

	for(phi_int=0; phi_int<700; phi_int+=1)
	{
		starttime = SDL_GetTicks();

		count2=0;
		if(phi_int>=200 && phi_int<600)
		{
		for(count2=0; count2<text_3D.ant_subs; count2 ++)
		{
			for(count=0; count<=text_3D.subs[count2].verts_in_sub; count++)
			{
				if(phi_int<400)
				{
					text_3D.subs[count2].vertex_list_y[count] *=0.006*sin((count-200)/10)+1;//1.002;
				}
				else
				{
					text_3D.subs[count2].vertex_list_y[count] /=0.006*sin((count-200)/10)+1;//1.002;
				}
//			text_3D.subs[count2].vertex_list_z[count] *=0.005*sin(count/10)+1;//1.002;
			}
		}
		}

	text_3D.rotate(2, 4);
//	text_3D.rotate(3, 2);
	while (SDL_LockSurface(screen) <0 );
	disp_buf(buffer_16, zero_adr_16);
/*	for(y=0; y<480; y++)
	{
		for(x=0; x<640; x++)
		{
			zero_adr_16[screen_pitch*y + x] = 0x0000;
		}
	}*/
	scale_fact = 8;
	for(count2=0; count2<text_3D.ant_subs; count2 ++)
	{
		for(count=0; count<text_3D.subs[count2].pols_in_sub; count++)
		{
//			draw_line(20, 20, 100, 100, 0xFFFF, zero_adr_16);
			point_1 = text_3D.subs[count2].polygons[count].ref_1;
			point_2 = text_3D.subs[count2].polygons[count].ref_2;
			point_3 = text_3D.subs[count2].polygons[count].ref_3;

			xf = (text_3D.subs[count2].vertex_list_x[point_1]*scale_fact);
			yf = (text_3D.subs[count2].vertex_list_y[point_1]*scale_fact);

			xf2 = (text_3D.subs[count2].vertex_list_x[point_2]*scale_fact);
			yf2 = (text_3D.subs[count2].vertex_list_y[point_2]*scale_fact);

			xf3 = (text_3D.subs[count2].vertex_list_x[point_3]*scale_fact);
			yf3 = (text_3D.subs[count2].vertex_list_y[point_3]*scale_fact);

//			printf("sub: %d, x2: %g, y2: %g, x3: %g, y3: %g\n", count2, xf2+300, yf2+200, xf3+300, yf3+200);
			draw_line(xf+320, yf+240, xf2+320, yf2+240, 0xFFFF, zero_adr_16);
			draw_line(xf+320, yf+240, xf3+320, yf3+240, 0xFFFF, zero_adr_16);
			draw_line(xf2+320, yf2+240, xf3+320, yf3+240, 0xFFFF, zero_adr_16);
		}
	}
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 20 && done==0);	{ if(are_done()) {done=1; phi_int=700;}}
	}
//	while(are_done()==0);




	scale_fact = 8;

	for(phi_int=0; phi_int<90000; phi_int+=1)
	{
		starttime = SDL_GetTicks();

	text_3D.rotate(1, 4);
	text_3D.rotate(3, 4);
	while (SDL_LockSurface(screen) <0 );
	disp_buf(buffer_16, zero_adr_16);
/*	for(y=0; y<480; y++)
	{
		for(x=0; x<640; x++)
		{
			zero_adr_16[screen_pitch*y + x] = 0x0000;
		}
	}
*/
	color_16 = 0xFFFF;
	write_text("THIS WAS OUR CONTRIBUTION TO THE FAST INTRO COMPO", 50, 480-phi_int, color_16, font_1, char_pos, zero_adr_16);
	write_text("GREETINGS FLY OUT TO:", 200, 480-phi_int+80, color_16, font_1, char_pos, zero_adr_16);
	write_text("ALL OF YOU HERE AT BREAKPOINT 2003", 120, 480-phi_int+120, color_16, font_1, char_pos, zero_adr_16);
	write_text("THE ORGANIZERS WHO MADE THIS POSSIBLE", 105, 480-phi_int+160, color_16, font_1, char_pos, zero_adr_16);
	write_text("ALL SCENERS AROUND THE WORLD", 160, 480-phi_int+200, color_16, font_1, char_pos, zero_adr_16);
	write_text("ALL PAST AND PRESENT DARKLITE MEMBERS", 105, 480-phi_int+240, color_16, font_1, char_pos, zero_adr_16);

	write_text("EPHIDRENA", 265, 480-phi_int+280, color_16, font_1, char_pos, zero_adr_16);
	write_text("HAUJOBB", 275, 480-phi_int+320, color_16, font_1, char_pos, zero_adr_16);
	write_text("SPACEBALLS", 260, 480-phi_int+360, color_16, font_1, char_pos, zero_adr_16);
	write_text("METALVOTZE", 255, 480-phi_int+400, color_16, font_1, char_pos, zero_adr_16);
	write_text("EXCESS", 280, 480-phi_int+440, color_16, font_1, char_pos, zero_adr_16);

	write_text("AND ALL THE GUYS FORGOTTEN", 180, 480-phi_int+480, color_16, font_1, char_pos, zero_adr_16);


	write_text("PLEASE HIT ESCAPE!", 220, 480-phi_int+800, color_16, font_1, char_pos, zero_adr_16);

	if(phi_int<100)
	{
		scale_fact -= 0.04;
	}
	else
	{
		scale_fact = 4;
	}

	if(phi_int<100)
	{
		x = 320;
		y = 240;
	}
	else
	{
		x = (int) (320+200*sin((phi_int-100)/63.67));
		y = (int) (240+100*cos((phi_int)/63.67));
	}


//	col_R = phi_int%32;
//	col_G = 64-phi_int%64;
//col_G = 63;
//	col_B = 32-phi_int%32;

	color_16  = col_R;			color_16 = color_16<<6;
	color_16 += col_G;			color_16 = color_16<<5;
	color_16 += col_B;

	color_16=0xFFFF;

	for(count2=0; count2<text_3D.ant_subs; count2 ++)
	{
		for(count=0; count<text_3D.subs[count2].pols_in_sub; count++)
		{
//			draw_line(20, 20, 100, 100, 0xFFFF, zero_adr_16);
			point_1 = text_3D.subs[count2].polygons[count].ref_1;
			point_2 = text_3D.subs[count2].polygons[count].ref_2;
			point_3 = text_3D.subs[count2].polygons[count].ref_3;

			xf = (text_3D.subs[count2].vertex_list_x[point_1]*scale_fact);
			yf = (text_3D.subs[count2].vertex_list_y[point_1]*scale_fact);

			xf2 = (text_3D.subs[count2].vertex_list_x[point_2]*scale_fact);
			yf2 = (text_3D.subs[count2].vertex_list_y[point_2]*scale_fact);

			xf3 = (text_3D.subs[count2].vertex_list_x[point_3]*scale_fact);
			yf3 = (text_3D.subs[count2].vertex_list_y[point_3]*scale_fact);

			draw_line(xf+x, yf+y, xf2+x, yf2+y, color_16, zero_adr_16);
			draw_line(xf+x, yf+y, xf3+x, yf3+y, color_16, zero_adr_16);
			draw_line(xf2+x, yf2+y, xf3+x, yf3+y, color_16, zero_adr_16);
		}

	}
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
	while((SDL_GetTicks() - starttime) < 20 && done==0);	{ if(are_done()) {done=1; phi_int=90000;}}
	}

	// 3D ENDS




	while (SDL_LockSurface(screen) <0 );
//	write_text("END OF INTRO!!!", 200, 230, 0xFFFF, font_1, char_pos, zero_adr_16);
//	write_text(text_3D.object_name, 100, 130, 0xFFFF, font_1, char_pos, zero_adr_16);
//	write_text(text_3D.subs[1].part_name, 300, 150, 0xFFFF, font_1, char_pos, zero_adr_16);
//	draw_line(20, 20, 100, 100, 0xFFFF, zero_adr_16);
	SDL_UnlockSurface(screen);	SDL_Flip(screen);
//	while (are_done()==0);


	printf("%d\n", SDL_GetTicks() - starttime2);
	for(count=0; count<text_3D.ant_subs; count++)
	{
		printf(text_3D.subs[count].part_name);
		printf("\n");
	}
	for(count=0; count<text_3D.ant_subs; count++)
		printf("Sub nr: %d,   ant pols: %d\n", count, text_3D.subs[count].pols_in_sub/*text_3D.ant_pols[count]*/);
//	printf("%g\n", text_3D.jall);

	FMUSIC_StopSong(mod);
	FMUSIC_FreeSong(mod);
	FSOUND_Close();

	delete [] buffer_16;
	delete [] font_1;
	delete [] shade_1;
	delete [] char_pos;
	delete [] c64font;
}
// INTRO ENDS








/////////////// count_sprite_8 ///////////////

int count_sprite_8(int x_start, int y_start, int x_stopp, int y_stopp, char *bitmap)
{
	int x, y;
	char count = 0;

	for(x=x_start; x<=x_stopp; x++)
	{
		for(y=y_start; y<=y_stopp; y++)
		{
			if(bitmap[y*320 + x] != 0)
			{
				count++;
				printf("%d\n", bitmap[320*y + x]);
			}
		}
	}

	printf("PIX: %d\n", count);
	return (count);
}



// DRAW A LINE BETWEEN TWO POINTS
void draw_line(float x_float1, float y_float1, float x_float2, float y_float2, Uint16 color, Uint16 *SDL_screen)
{
	float         slope, fdelta_x, fdelta_y, x_float, y_float;
	int           x, y;


	fdelta_x = x_float2 - x_float1;				// Calc length of vector.
	fdelta_y = y_float2 - y_float1;				// Calc hight of vector.

	slope = fdelta_y/(fdelta_x+0.0001);			// Calc slope of vector (+ 0.0001 to avoid div by zero).
	if (slope<=1 && slope>=-1)
	{
		y_float=y_float1;
		for (x=RND(x_float1); x<=RND(x_float2); x++)
		{
			y_float += (slope);
			y = (int) y_float;
			if (y_float>=(y+0.5))
				y++;
			SDL_screen[screen_pitch*y + x]=color;
		}
	}

	else
	{
		slope = fdelta_x/fdelta_y;
		x_float=x_float1;
		for (y=RND(y_float1); y<=RND(y_float2); y++)
		{
			x_float += (slope);
			x = (int) x_float;
			if (x_float>=(x+0.5))
				x++;
			SDL_screen[screen_pitch*y + x]=color;
		}
	}
}



// DISPLAY A BUFFER
void disp_buf(Uint16 *buffer, Uint16 *SDL_screen)
{
	long 		temp1, temp2;
	long 		count;
	int		x, y;


	for(y=0; y<480; y++)
	{
		temp1 = screen_pitch*y;
		temp2 = 640*y;
		for(x=0; x<640; x++)
		{
			SDL_screen[temp1 + x] = buffer[temp2 + x];
			count++;
		}
	}
}



// FADE OUT
void fade_out(Uint16 *virtscr_from, Uint16 *virtscr_to, int count, Uint16 *R, Uint16 *G, Uint16 *B)
{
	long   		index;
	int    		index_int;
	int		x, y, y_temp, temp2;
	long 		temp;
	Uint16  	color_16;
	Uint16		col_R, col_G, col_B;


	for (index_int=0; index_int<32; index_int++)
	{
		if(R[index_int]>0)
			R[index_int]-=1;
//		G[63-index_int*2]+=2;
		if(G[index_int+32]>1)
			G[index_int+32]-=2;
//		G[50-index_int]+=1;
		if(B[index_int]>0)
			B[index_int]-=1;
	}

	for(y=0; y<480; y++)
	{
		y_temp = 640*y;
		temp = screen_pitch*y;

		for(x=0; x<640; x++)
		{
			color_16 = virtscr_from[y_temp + x];

			col_R = col_G = col_B = color_16;
			col_R = col_R>>11;
			col_G = col_G<<5; col_G = col_G>>10;
			col_B = col_B<<11; col_B = col_B>>11;

			col_R = R[col_R];
			col_G = G[col_G];
			col_B = B[col_B];

			color_16  = col_R;			color_16 = color_16<<6;
			color_16 += col_G;			color_16 = color_16<<5;
			color_16 += col_B;

			virtscr_to[temp + x] = color_16;
		}
	}
}



// FADE IN
void fade_in(Uint16 *virtscr_from, Uint16 *virtscr_to, int count, Uint16 *R, Uint16 *G, Uint16 *B)
{
	long   		index;
	int    		index_int;
	int		x, y, y_temp, temp2;
	long 		temp;
	Uint16  	color_16;
	Uint16		col_R, col_G, col_B;


	for (index_int=0; index_int<=count; index_int++)
	{
		R[31-index_int]+=1;
//		G[63-index_int*2]+=2;
		G[63-index_int]+=2;
//		G[50-index_int]+=1;
		B[31-index_int]+=1;
	}

	for(y=0; y<480; y++)
	{
		y_temp = 640*y;
		temp = screen_pitch*y;

		for(x=0; x<640; x++)
		{
			color_16 = virtscr_from[y_temp + x];

			col_R = col_G = col_B = color_16;
			col_R = col_R>>11;
			col_G = col_G<<5; col_G = col_G>>10;
			col_B = col_B<<11; col_B = col_B>>11;

			col_R = R[col_R];
			col_G = G[col_G];
			col_B = B[col_B];

			color_16  = col_R;			color_16 = color_16<<6;
			color_16 += col_G;			color_16 = color_16<<5;
			color_16 += col_B;

			virtscr_to[temp + x] = color_16;
		}
	}
}



// LOAD A 640*480*24 TGA-PICTURE AN MAKE IT AN 640*480*16 BITMAP
void load_640(char *fil, Uint16 *bitmap)
{
	Uint16		color_16;
	Uint16		col_R, col_G, col_B;
	char		*buffer = new char[921600];
	long		count, count2;


	ifstream pict_file(fil);
	pict_file.seekg(18);
	pict_file.read(buffer, 921600);
	pict_file.close();

//	ichbin_16 = new Uint16[307200];
	count = 0;
	count2 = 0;
	while(count<921600)
	{
		col_B = buffer[count]>>3;
		count++;
		col_G = buffer[count]>>2;
		count++;
		col_R = buffer[count]>>3;
		count++;

		color_16  = col_R;			color_16 = color_16<<6;
		color_16 += col_G;			color_16 = color_16<<5;
		color_16 += col_B;

		bitmap[count2] = color_16;
		count2++;
	}

	delete [] buffer;
}



// WRITE TEXT TO A SDL-SCREEN
void write_text(char *text, int x_text, int y_text, Uint16 col_org, char *font_bitmap, int *chars, Uint16 *SDL_screen)
{
	int x_start, x_stopp, y_start, y_stopp;
	int x, y, x_temp, y_temp;
	int char_width=0;
	int temp;
    	int length = strlen(text);


	for (int index=0; index<length; index++)
	{
		if (text[index]!=' ' && text[index]!='\n')
		{
			if (text[index]>='A' && text[index]<='Z')
				temp = (text[index] - 65)<<2;
			else if (text[index]>='0' && text[index]<='9')
				temp = (text[index] - 22)<<2;
			else if (text[index]=='.')
				temp = 39<<2;
			else if (text[index]=='!')
				temp = 37<<2;
			else if (text[index]==':')
				temp = 38<<2;
			else if (text[index]=='?')
				temp = 36<<2;
			else if (text[index]==',')
				temp = 40<<2;
			else if (text[index]=='-')
				temp = 41<<2;
			else if (text[index]=='_')
				temp = 42<<2;

			x_start = chars[temp + 0];
			y_start = chars[temp + 1];
			x_stopp = chars[temp + 2];
			y_stopp = chars[temp + 3];
			for (x=x_start; x<=x_stopp; x++)
			{
				for (y=y_start; y<=y_stopp; y++)
				{
					if (font_bitmap[(y<<8)+(y<<6) + x] == 0)
					{
						x_temp = (x - x_start) + x_text + char_width;
						y_temp = (y - y_start) + y_text;

						if ((y_temp>=0 && y_temp<397) && (x_temp>=0 && x_temp<639))
						{
							SDL_screen[y_temp*screen_pitch + x_temp] = col_org;
						}
/*						if ((y_temp>=0 && y_temp<397) && (x_temp>=0 && x_temp<639))
						{
							SDL_screen[y_temp*screen_pitch + x_temp+1] = col_org;
						}
						if ((y_temp>=0 && y_temp<397) && (x_temp>=0 && x_temp<639))
						{
							SDL_screen[(y_temp+1)*screen_pitch + x_temp] = col_org;
						}
						if ((y_temp>=0 && y_temp<397) && (x_temp>=0 && x_temp<639))
						{
							SDL_screen[(y_temp+1)*screen_pitch + x_temp+1] = col_org;
						}
*/					}
				}
			}
			char_width += x_stopp - x_start + 1;
		}
		else char_width += 6;
	}
}



// SYSTEM FOR THE C64-FONT
void type_text(char *text, int text_x, int text_y, Uint16 color, Uint16 *virtscr, char *bitmap)
{
	int  x, y;
	int  x_start, x_stop, y_start, y_stop;
	int  length = strlen(text);
	int  temp_1, temp_2;

	x_start=0; x_stop=15;
	for (int index=0; index<length; index++)
	{
		if (text[index]!=' ')
		{
			if (text[index]>='A' && text[index]<='M')
			{
				y_start = 0;
				y_stop = 12;
				x_start = (text[index]-65) * 26;
				x_stop = x_start + 14;
			}
			else
			if (text[index]>='N' && text[index]<='Z')
			{
				y_start = 17;
				y_stop = 29;
				x_start = (text[index]-78) * 26;
				x_stop = x_start + 14;
			}
			else
			if (text[index]>='0' && text[index]<='9')
			{
				y_start = 34;
				y_stop = 46;
				x_start = (text[index]-48) * 26;
				x_stop = x_start + 14;
			}
			else
			{
				y_start = 51; y_stop =63;
			}

			if (text[index] == '_')
			{ x_start = 286; x_stop = 299; }
			if (text[index] == '*')
			{ x_start = 237; x_stop = 244; }
			if (text[index] == '.')
			{ x_start = 5; x_stop = 8; }
			if (text[index] == ',')
			{ x_start = 30; x_stop = 34; }
			if (text[index] == 'f')
			{ x_start = 185; x_stop = 193; }


			for (y=y_start; y<=y_stop; y++)
			{
				for (x=x_start; x<=x_stop; x++)
				{
					if (bitmap[550*y + x] != 0)
						virtscr[screen_pitch*(y+text_y-y_start) + (x+text_x-x_start+index*14)] = color;
				}
			}

		}
	}
}



// CHECK FOR QUIT EVENTS
int are_done(void)
{
	while (SDL_PollEvent(&event))
	{
		if (event.type == SDL_QUIT)
			return 1;

		if (event.type == SDL_KEYDOWN)
		{
			if (event.key.keysym.sym == SDLK_ESCAPE)
				return 1;
		}
	}
	return 0;
}
